<?php

	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

	//require_once( dirname(__FILE__) . "/app.php.inc" );
	//require_once( dirname(__FILE__) . "/xmlutil.php.inc" );
	//require_once( dirname(__FILE__) . "/user.php.inc" );	// 2005.07.28 ɲáǡαΰ١
	require_once( dirname(__FILE__) . "/viewcore.php.inc" );
	require_once( dirname(__FILE__) . "/cache.php.inc" );
	
	// å󳫻
	cmsd_session_start();

	mb_language( 'Japanese' );
	mb_internal_encoding( 'EUC-JP' );

	//set_error_handler( "error_handler" );
  	//ob_start("execute_cmsd_command");
	ob_start();
	
	function cmsd_end_template()
	{
		// ֥饦åȥХåӡIf-Modified-Sinceб
		$cacheID = ADPageCache::createCacheIDFromRequest();
		$etag = md5( $cacheID );	// EtagURL
		
		// ExpiresإåѤΥ֥饦å֡
		/// δ֡If-Modified-Since䤤碌̵ʤ륱ʥ֥饦ˤˡޤĹȥƥĹ桼ϤΤ٤ʤ롣
		/// ĹǤ1(3600*24)餤ˤƤȡ
		$cacheInterval = 60; // [sec]
		
		// å夬ͭ¸ߤͭǤС˽Ϥƽλ롣
		if ( ADPageCache::isEnabled() && ADPageCache::exists( $cacheID ) && ! ADPageCache::isExpired( $cacheID ) )
		{
			// ϥХåեöϤ򥯥ꥢ롣
			$buffer = ob_get_contents();
			ob_end_clean();
			
			// ֥饦åꥵХåιŤС$modifiedfalse̤ˤˤ롣
			$timestamp = filemtime( ADPageCache::getCacheFilePath( $cacheID ) );
			$sLastModified = gmdate('D, d M Y H:i:s T', $timestamp);	
			$modified = true;
			
			if( isset( $_SERVER['HTTP_IF_MODIFIED_SINCE'] ) ) {
				$since = parse_http_date( $_SERVER['HTTP_IF_MODIFIED_SINCE'] );
				if( $since["timestamp"] >= $timestamp ) {
					$modified = false;
				}
			}
			
			// å夬̤ʤ顢304 Not Modified֤ƽλ
			if ( ! $modified )
			{
				// PHPΥǥեno-cacheƤޤ褦ʤΤǡExpiresCache-controlPragma񤭤롣
				
				header( "HTTP/1.1 304 Not Modified" );
				
				header( "Expires: " . gmdate( "D, d M Y H:i:s", time() + $cacheInterval ) . " GMT" );
				header( "Cache-Control: max-age=" . $cacheInterval);
				header( "Pragma: cache"); // no-cacheʳ
				
				header( "Etag: \"$etag\"" );
				header( "Last-Modified: " . $sLastModified );
				return;		// ǽλ
			}
			else
			{
				header( "Expires: " . gmdate( "D, d M Y H:i:s", time() + $cacheInterval ) . " GMT" );
				header( "Cache-Control: max-age=" . $cacheInterval);
				header( "Pragma: cache"); // no-cacheʳ

				header( 'ETag: "' . $etag . '"' );
				header( "Last-Modified: " . $sLastModified );
				
				// å֤
				ADPageCache::outputCache( ADPageCache::createCacheIDFromRequest() );
			}
			
			return;
		}
	
		// OutputConfigɤ߹
		$siteConfig = new CMSSiteConfig();
		$outputConfig =& $siteConfig->getOutputConfig();	// 󥹥󥹤ѹ١ȤǼ롣
		
		// XSLT饤ֹ֥
		ADXslt::setXsltLibNo( $outputConfig->getXsltLibNo() );
		
		// XSLTˤʸ󥳡ǥ󥰽̵ͭ
		ADXslt::setDisableXsltEncoding( $outputConfig->getDisableXsltEncoding() );
		
		// ϥХåեöϤ򥯥ꥢ롣
		$buffer = ob_get_contents();
		ob_end_clean();
		$pagedata = execute_cmsd_command( $buffer );
		
		// ʸɤη
		$outputEncoding = $outputConfig->getEncoding();	// execute_cmsd_command᥽åǡʸɤ꤬ѹƤ礬롣
		
		// HTTPإåѤʸ
		// ܤɤȤ륨󥳡ǥ󥰤Τб
		$httpHeaderEncoding = ''; // ͤϤʤ
		if ( strcasecmp( $outputEncoding, 'ISO-2022-JP' ) == 0 ) {
			$httpHeaderEncoding = 'ISO-2022-JP';
		}
		else if ( strcasecmp( $outputEncoding, 'Shift_JIS' ) == 0 ) {
			$httpHeaderEncoding = 'Shift_JIS';
		}
		else if ( strcasecmp( $outputEncoding, 'EUC-JP' ) == 0 ) {
			$httpHeaderEncoding = 'EUC-JP';
		}
		else if ( strcasecmp( $outputEncoding, 'UTF-8' ) == 0 ) {
			$httpHeaderEncoding = 'UTF-8';
		}
		
		// إå˥󥳡ǥ󥰤
		// ľ $outputEncodingϤʤͳϡإåؤιǽ˾١
		if ( $httpHeaderEncoding != '' )
		{
			header( 'Content-Type: text/html; charset=' . $httpHeaderEncoding );
		}
		
		// METAѽʸɤη
		$metaEncoding = strtolower( $outputEncoding );
		if ( strcasecmp( $outputEncoding, 'shift_jis' ) == 0 or strcasecmp( $outputEncoding, 'sjis' ) == 0 )
		{
			$outputEncoding = 'SJIS-win'; // SJIS-win
			$metaEncoding = 'shift_jis';
		}
		
		// ʸѴ
		if ( strcasecmp( $outputEncoding, 'EUC-JP' ) != 0 and strcasecmp( $outputEncoding, 'PASS' ) != 0 )	// EUC-JP or PASS ξʸѴԤʤ
		{
			// metacharsetִ롣
			if ( $outputConfig->getMetaTagReplacement() )
			{
				$pagedata = str_replace( array( 'charset=euc-jp"', 'charset=EUC-JP"', 'charset="EUC-JP"', 'charset="euc-jp"' ), array( "charset={$metaEncoding}\"", "charset={$metaEncoding}\"", "charset=\"{$metaEncoding}\"", "charset=\"{$metaEncoding}\"" ), $pagedata );
			}
		
			// ʸ󥳡ɤѴ롣
			$pagedata = mb_convert_encoding( $pagedata, $outputEncoding, 'eucJP-win'.'' ); // eucJP-win
		}
		
		// å夬ͭʤ顢å
		if ( ADPageCache::isEnabled() )
		{
			// å
			ADPageCache::createCache( $cacheID, $pagedata );
			
			// å夬¸ߤƤ顢ΥåդLast-Modified֤
			if ( ADPageCache::exists( $cacheID ) )
			{
				$timestamp = filemtime( ADPageCache::getCacheFilePath( $cacheID ) );
				$sLastModified = gmdate('D, d M Y H:i:s T', $timestamp);
				
				header( "Expires: " . gmdate( "D, d M Y H:i:s", time() + $cacheInterval ) . " GMT" );
				header( "Cache-Control: max-age=" . $cacheInterval);
				header( "Pragma: cache"); // no-cacheʳ
				
				header('ETag: "' . $etag . '"' );
				header("Last-Modified: " . $sLastModified );
			}
		}
		
		// 
		print $pagedata;
	}
	
	function proc_cmsd_tag( $cmsdTag )
	{
		$result = '';
		
		// νľΥɤ߹߽compilation error顼ХåեίޤäƤꡢ򵯤١ö顼򥯥ꥢ롣
		if ( function_exists( 'libxml_clear_errors' ) )
		{
			libxml_clear_errors();
		}
	
		//$old_error_reporting = error_reporting( E_ALL ^ ( E_NOTICE | E_WARNING ) );
		$errors = array();
		$xmlDocCommand = @domxml_open_mem('<?xml version="1.0"	encoding="UTF-8" ?><cmsdtag xmlns:cmsd="http://cms.al-design.jp/CMSDTAGS" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">' . mb_convert_encoding(  $cmsdTag, 'UTF-8', 'EUC-JP' ) . '</cmsdtag>', DOMXML_LOAD_PARSING, $errors );
		//error_reporting( $old_error_reporting );
		
		if( is_null( $xmlDocCommand ) or count( $errors ) > 0 ) {
			return "CMSD tag error. tag='" . htmlentities($cmsdTag) . "', errormessage = " . $errors[0]['errormessage'];
		}
		
		// Namespaceΰ٤˥ߡͿcmsdtagǤӽ롣
		$xmlDammyRoot = $xmlDocCommand->document_element();
		$xmlRoot = $xmlDammyRoot->first_child();
		
		//return "<font color=\"red\">TEST1:" . $xmlRoot->tagname() . "</font>";
		
		switch ( $xmlRoot->tagname() )
		{
			case 'entry' :
			case 'cmsd:entry' : // PHP5б
				// ȥ̾
				$name = $xmlRoot->get_attribute('name');				// ȥե̾
				$eid = $xmlRoot->get_attribute('eid');					// ȥID
				$design = $xmlRoot->get_attribute('design');			// ǥ̾
				$navigation = $xmlRoot->get_attribute('navigation');	// ʥӥOn/Off
				$output = $xmlRoot->get_attribute('output');			// Ϸ html/xml
				//$rows = $xmlRoot->get_attribute('rows');				// 1ڡ˽ϤԿ
				$tagremoving = $xmlRoot->get_attribute('tagremoving');	// 
				//$cols = $xmlRoot->get_attribute('cols');				// ơ֥Ǥν
				$dataname = $xmlRoot->get_attribute('dataname');		// ñ̤νϻ
				$rows = $xmlRoot->get_attribute('rows');				// 1ڡ˽ϤԿ2006.2.16 ɲá
				$interlock = $xmlRoot->get_attribute('interlock');		// -ܺϢư 'yes' | 'no'2006.2.16 ɲá
				
				// åname̤
				if ( strlen( $name ) <= 0 )
				{
					return "cmsd:entryname°ꤵƤޤ";
				}
				
				// ȥե̾ȥID
				$v = new entry_view( $name, $eid );
				
				// 
				if ( $tagremoving == 'on' )
				{
					$v->tagRemovingOn();
				}
				
				//die( "interlock='{$interlock}', name='$name', dataname='$dataname'" );
				
				// -ܺϢưꡣ2006.2.16 ɲá
				if ( $interlock == 'yes' )
				{
					$v->interlockOn();
				}
				
				// 1ڡϷ
				if ( is_numeric( $rows ) )
				{
					$v->setPageMaxRows( $rows );
				}
								
				// ʥӥOn
				if ( $navigation == 'on' )
				{
					$v->navigationOn();
				}
				
				// 롼ץ
				$xmlGroups = $xmlRoot->get_elements_by_tagname( 'group' );
				foreach( $xmlGroups as $xmlGroup )
				{
					$groupKey = $xmlGroup->get_attribute('key');
					$groupValue = $xmlGroup->get_attribute('value');
					$v->addGroupKey( $groupKey, $groupValue );
				}
				
				// ѥ᡼
				$xmlParams = $xmlRoot->get_elements_by_tagname( 'param' );
				foreach( $xmlParams as $xmlParam )
				{
					$paramKey = $xmlParam->get_attribute('key');
					$paramValue = $xmlParam->get_attribute('value');
					$v->addParamKey( $paramKey, $paramValue );
				}
				
				// 饤ǥλ
				// 롼ץ
				$xmlDesigns = $xmlRoot->get_elements_by_tagname( 'design' );
				foreach( $xmlDesigns as $xmlDesign )
				{
					// designǤλƤʸȤƼinlineXslt˥åȡ
					$inlineXslt = '';
					foreach( $xmlDesign->child_nodes() as $xmlDesignChild )
					{
						$inlineXslt .= $xmlDocCommand->dump_node( $xmlDesignChild );
					}
					
					$v->setInlineXslt( $inlineXslt );
					
				}
				
				// ܤΤߤνϤ
				if ( $dataname )
				{
					// ñ̤νϤԤ
					return $v->getdata( $dataname );
				}
				else
				{
					// ̾ΥȥϤԤ
					// xml
					if ( $output == 'xml' )
					{
						// OutputConfigɤ߹
						$siteConfig = new CMSSiteConfig();
						$outputConfig =& $siteConfig->getOutputConfig();	// 󥹥󥹤ѹ١ȤǼ롣
						$outputConfig->setEncoding('pass');	// xmlξ硢ϤUTF-8ˤʤäƤΤѴס
					
						// XMLǤν
						return $v->getxml( $design );
					}
					else
					{
						return $v->gethtml( $design );
					}
				}
			
				break;
			
			case 'entrylist' :
			case 'cmsd:entrylist' : // PHP5б

				// ȥ̾
				$name = $xmlRoot->get_attribute('name');				// ȥե̾
				$pageno = $xmlRoot->get_attribute('pageno');			// ڡֹ
				$design = $xmlRoot->get_attribute('design');			// ǥ̾
				//$navigation = $xmlRoot->get_attribute('navigation');	// ʥӥOn/Off  ȥξ硢pageno='top'ȤмưŪ˥ʥӥOffˤʤΤס
				$output = $xmlRoot->get_attribute('output');			// Ϸ html/xml
				$rows = $xmlRoot->get_attribute('rows');				// 1ڡ˽ϤԿ
				$tagremoving = $xmlRoot->get_attribute('tagremoving');	// 
				$cols = $xmlRoot->get_attribute('cols');				// ơ֥Ǥν
				$interlock = $xmlRoot->get_attribute('interlock');		// -ܺϢư 'yes' | 'no'2006.2.16 ɲá
				
				// åname̤
				if ( strlen( $name ) <= 0 )
				{
					return "cmsd:entryname°ꤵƤޤ";
				}
				
				// 
				if ( empty( $rows ) )
				{
					$rows = 10;	// ͤ
				}
				
				// ȥե̾ڡֹ
				$v = new entrylist_view( $name, $pageno );
				
				//$result .= 'entrylist tag <br />';
				
				// 
				if ( $tagremoving == 'on' )
				{
					$v->tagRemovingOn();
				}
				
				// -ܺϢưꡣ2006.2.16 ɲá
				if ( $interlock == 'yes' )
				{
					$v->interlockOn();
				}
				
				// ơ֥Ǥν
				if ( ! empty( $cols ) )
				{
					$v->setCols( $cols );
				}
				
				// 롼ץ
				$xmlGroups = $xmlRoot->get_elements_by_tagname( 'group' );
				foreach( $xmlGroups as $xmlGroup )
				{
					$groupKey = $xmlGroup->get_attribute('key');
					$groupValue = $xmlGroup->get_attribute('value');
					/*
					if ( empty( $groupValue ) )
					{
						$groupValue = null;
					}
					*/
					$v->addGroupKey( $groupKey, $groupValue );
					//$result .= 'groupKey = ' . $groupKey . ', groupValue = ' . $groupValue . '<br />';
					
				}
				
				// ѥ᡼
				$xmlParams = $xmlRoot->get_elements_by_tagname( 'param' );
				foreach( $xmlParams as $xmlParam )
				{
					$paramKey = $xmlParam->get_attribute('key');
					$paramValue = $xmlParam->get_attribute('value');
					$v->addParamKey( $paramKey, $paramValue );
				}
				
				// ȥ
				$xmlSorts = $xmlRoot->get_elements_by_tagname( 'sort' );
				foreach( $xmlSorts as $index=>$xmlSort )
				{
					// ȥ
					$sortKey = $xmlSort->get_attribute('key');
					$sortOrder = $xmlSort->get_attribute('order');
					$sortKeyType = $xmlSort->get_attribute('type');
					$sortName = $xmlSort->get_attribute('name');
					
					if ( ! empty( $sortName ) )
					{
						// nameꤵƤϡURLʤΤ¾ѥ᡼̵뤹롣
						$v->addSortKey( $sortName );
					}
					else
					{
						// nameꤵƤʤϡƥѥ᡼ꤹ롣1ѥ᡼̡ͥ2ѥ᡼'key,order,type'η
						$v->addSortKey( $index, $sortKey . ',' . $sortOrder . ',' . $sortKeyType );
					}
				}
				
				// 饤ǥλ
				// 롼ץ
				$xmlDesigns = $xmlRoot->get_elements_by_tagname( 'design' );
				foreach( $xmlDesigns as $xmlDesign )
				{
					// designǤλƤʸȤƼinlineXslt˥åȡ
					$inlineXslt = '';
					foreach( $xmlDesign->child_nodes() as $xmlDesignChild )
					{
						$inlineXslt .= $xmlDocCommand->dump_node( $xmlDesignChild );
					}
					
					$v->setInlineXslt( $inlineXslt );
					
				}
				
				// OutputConfigɤ߹
				$siteConfig = new CMSSiteConfig();
				$outputConfig =& $siteConfig->getOutputConfig();	// 󥹥󥹤ѹ١ȤǼ롣
				
				// xml
				if ( $output == 'xml' )
				{
					$outputConfig->setEncoding('pass');	// xmlξ硢ϤUTF-8ˤʤäƤΤѴס
					$result .= $v->getxml( $design, $rows );
				}
				elseif ( $output == 'rss' )
				{
					$outputConfig->setEncoding('pass');	// rssξ硢ϤXSLT¦ǴUTF-8ˤʤäƤΤѴס
					$result .= $v->getrss( $design );
				}
				else
				{
					$result .= $v->gethtml( $design, $rows );
				}
				
				break;
				
				
			case 'searchresult' :
			case 'cmsd:searchresult' : // PHP5б
			
				// ȥ̾
				$design = $xmlRoot->get_attribute('design');			// ǥ̾
				$rows = $xmlRoot->get_attribute('rows');				// 1ڡ˽ϤԿ2006.2.16 ɲá
				
				// ȥե̾ȥID
				$v = new searchresult_view();
				
				// оݥȥե
				$xmlTargets = $xmlRoot->get_elements_by_tagname( 'searchtarget' );
				
				if ( empty( $xmlTargets ) )
				{
					return "cmsd:searchresultcmsd:searchtarget1Ĥ⤢ޤ";
				}
				
				foreach( $xmlTargets as $xmlTarget )
				{
					$name = $xmlTarget->get_attribute('name');
					$title = $xmlTarget->get_attribute('title');
					$pageurl = $xmlTarget->get_attribute('pageurl');
					
					if ( strlen( $name ) <= 0 )
					{
						return "cmsd:searchtargetname°ꤵƤޤ";
					}
					
					if ( strlen( $title ) <= 0 )
					{
						return "cmsd:searchtargettitle°ꤵƤޤ";
					}
					
					if ( strlen( $pageurl ) <= 0 )
					{
						return "cmsd:searchtargetpageurl°ꤵƤޤ";
					}
					
					$v->addTarget( $name, $title, $pageurl );
				}
				
				// 饤ǥλ
				// 롼ץ
				$xmlDesigns = $xmlRoot->get_elements_by_tagname( 'design' );
				foreach( $xmlDesigns as $xmlDesign )
				{
					// designǤλƤʸȤƼinlineXslt˥åȡ
					$inlineXslt = '';
					foreach( $xmlDesign->child_nodes() as $xmlDesignChild )
					{
						$inlineXslt .= $xmlDocCommand->dump_node( $xmlDesignChild );
					}
					
					$v->setInlineXslt( $inlineXslt );
					
				}
				
				return $v->output( $design, $rows );
			
				break;
				
			case 'xml' :
			case 'cmsd:xml' : // PHP5б
			
				// °ɤ߹
				$src = parseString( $xmlRoot->get_attribute('src'), null) ;			// XMLΥѥ
				$design = parseString( $xmlRoot->get_attribute('design'), null );	// ǥ̾
				
				// åsrc̤
				if ( strlen( $src ) <= 0 )
				{
					return "cmsd:xmlsrc°ꤵƤޤ";
				}
				
				// ȥե̾ȥID
				$v = new externalxml_view( $src );
				
				if ( is_null( $design ) )
				{
					$result = $v->output( null, true );
				}
				else
				{
					$result = $v->output( $design );
				}
			
				break;
				
			
			// ڡΥ󥳡ǥ
			case 'output' :
			case 'cmsd:output' : // PHP5б
			
				$outputEncoding = parseString( $xmlRoot->get_attribute('encoding'), null) ;							// ʸ󥳡ɻʻʤξnull
				$disableXsltEncoding = parseBoolean( $xmlRoot->get_attribute( 'disable-xslt-encoding' ), null );	// XSLTʸ󥳡ǥ̵
				$metaTagReplacement = parseBoolean( $xmlRoot->get_attribute( 'meta-tag-replacement' ), null );		// ᥿charsetִ
				$xsltLibNo = parseNumeric( $xmlRoot->get_attribute( 'xslt-libno' ), null );							// XSLT-Libֹ
				
				// XSLT饤ֹ֥
				if ( ! is_null( $xsltLibNo ) )
				{
					ADXslt::setXsltLibNo( $xsltLibNo );
				}
				
				// XSLTˤʸ󥳡ǥ󥰽̵ͭ
				if ( ! is_null( $disableXsltEncoding ) )
				{
					ADXslt::setDisableXsltEncoding( $disableXsltEncoding );
				}
				
				// OutputConfigɤ߹
				$siteConfig = new CMSSiteConfig();
				$outputConfig =& $siteConfig->getOutputConfig();	// 󥹥󥹤ѹ١ȤǼ롣
				
				// ʸɻ
				if ( ! is_null( $outputEncoding ) )
				{
					$outputConfig->setEncoding( $outputEncoding );
				}
				
				// ᥿charsetִ
				if ( ! is_null( $metaTagReplacement ) )
				{
					$outputConfig->setMetaTagReplacement( $metaTagReplacement );
				}
				
				break;
		
		}
		
		return $result;
		
		//return '<font color="green">' . $xmlRoot->tagname() . '</font>';
		
	
		//return '<font color="green">' . htmlentities( $cmsdTag ) . '</font>';
	}
	
	
	/* ---------------------------------------------------------------
	 * 
	 * $buffer : ϥХåե
	 */	
	function execute_cmsd_command( $buffer )
	{
		$tagName = '';
		$output = '';
		$parsingText = '';
		$mode = 'text';
		
		// ХåեԤsplit롣
		//$lineArr = explode( "\n", $buffer );
		//$lineIndex = 0;
		
		$parsingText = $buffer;
		
		while ( $parsingText != '' )
		{
		
			if ( $mode=='text' )
			{
				//print "mode = text<br />";
				preg_match( "/<cmsd:([a-z\-]+)/", $parsingText, $matches, PREG_OFFSET_CAPTURE );
				if ( $matches )	// ޥåʥޥåȡ$matches[0][0]˥ޥåʸΤ$matches[0][1]˥ޥåʬΥեåȤ$matches[1][0]ˤ()ʬʸ$matches[1][1]ˤϤΥեåȤ롣
				{
					// Ĥä顢Ф򳫻Ϥ롣
					
					// ̾ݻƤ
					$tagName = $matches[1][0];
					
					$matchespos = mb_strpos( $parsingText, $matches[0][0] );	// substrȤȡܸޤʸ򤦤ޤǤʤ륵Ф㤬𤵤줿١mbϤ֤matches[0][1]ˤʸĹǤϤʤХĹ١mb_strposȤäƺƸ롣
					//die( 'matchespos = ' . $matchespos . ', parse = ' . substr( $parsingText, $matchespos ) );
					
					$output .= mb_substr( $parsingText, 0, $matchespos ); //$matches[0][1] );  // posʸ
					$parsingText = mb_substr( $parsingText, $matchespos ); //$matches[0][1] );	//posʸʸ
					$mode = 'tag_starting';
					
					//print "tagName = $tagName<br />";
				}
				else
				{
					// Ĥʤä顢ƽϤƤޤ
					$output .= $parsingText;
					$parsingText = '';
					
					//print "tag was not found.<br />";
				}
				
				
			}
			else if ( $mode=='tag_starting' )
			{
				//print '<span style="color:red">parsingText = "' . $parsingText . '"</span><br />';
				//print "mode = tag_starting<br />";
				preg_match( "/^(<cmsd:[^<]*\/>)/", $parsingText, $matches, PREG_OFFSET_CAPTURE );
				if ( $matches )
				{
					// Ĥä顢Фλ¹Ԥ롣
					$cmsdTag = $matches[1][0];//substr( $parsingText, 0, $pos + 2 );  //pos+ʸ ʸ
					
					// ¹ԡ
					$output .= proc_cmsd_tag( $cmsdTag );
					
					// Ĥtext⡼ɤǺƽ˲󤹡
					$parsingText = mb_substr( $parsingText, mb_strlen( $matches[1][0] ) ); // substr( $parsingText, $pos + 2 ); //pos+ʸ ʸʸ
					$mode = 'text';
					
					//print "cmsdTag executed.<br />";
					//print " - " . htmlentities( $cmsdTag ) . "<br />";
				}
				else
				{
					preg_match( "/^(<cmsd:[^<]*>)/", $parsingText, $matches, PREG_OFFSET_CAPTURE );
					if ( $matches )
					{
						// Ĥä顢ϺѤȤФ³Ԥ롣
						$mode = 'tag_started';
						//print "tagend.<br />";
					}
					else
					{
						// ĤƤ餺顼ʤΤǡ顼åϤƽλ
						$output .= "[ Error! '&lt;cmsd:$tagName&gt;' tag isn't ended. ]"; //$parsingTest;
						$parsingText = '';
						//print "error! tagend was not found.<br />";
					}
				}
			}
			else if ( $mode=='tag_started' )
			{
				//print "mode = tag_started<br />";
				$pos = mb_strpos( $parsingText, "</cmsd:$tagName>" );	//Ĥʤstrposfalse֤
				if ( $pos !== false )
				{
					// Ĥä顢Фλ¹Ԥ롣
					$cmsdTag = mb_substr( $parsingText, 0, $pos + mb_strlen( "</cmsd:$tagName>" ) ); //pos+ʸ ʸ
					
					// ¹ԡ
					$output .= proc_cmsd_tag( $cmsdTag );
					
					// Ĥtext⡼ɤǺƽ˲󤹡
					$parsingText = mb_substr( $parsingText, $pos + mb_strlen( "</cmsd:$tagName>" ) ); //pos+ʸ ʸʸ
					$mode = 'text';
					
					//print "cmsdTag executed.<br />";
					//print " - " . htmlentities( $cmsdTag ) . "<br />";
				}
				else
				{
					// ĤƤ餺顼ʤΤǡ顼åϤƽλ
						$output .= "[ Error! '&lt;/cmsd:$tagName&gt;' closing-tag doesn't exist. ]"; //$parsingTest;
					$parsingText = '';

					//print "error! closetag was not found.<br />";
				}
				
			}
		
		}
		
		
		return $output;
  
	}



?>